#include <stdlib.h>
#include <stdio.h>

void indeksujf(float**A , float*x, float*B, int n) {
	int i, j;
	
	for (i=0; i<n; i++)
		for (j=0; j<n; j++)
			A[i][j] = 1.0/(i+j+2);

	for (i=0; i<n; i++) {
		B[i] = 0;
		for (j=0; j<n; j++)
			B[i] += x[j]*A[i][j];
	}
}

void indeksujd(double**A , double*x, double*B, int n) {
	int i, j;
	
	for (i=0; i<n; i++)
		for (j=0; j<n; j++)
			A[i][j] = 1.0/(i+j+2);

	for (i=0; i<n; i++) {
		B[i] = 0;
		for (j=0; j<n; j++)
			B[i] += x[j]*A[i][j];
	}
}

void eliminacjaf(float** A, float*B, int n) {
	int i, j, k;
	float tmp;

	for (i=0; i<n; i++)
		for (j=i+1; j<n; j++) {
			tmp = A[j][i];	
			for (k=i; k<n; k++)
				A[j][k] -= A[i][k]*tmp/A[i][i];
			B[j] -= B[i]*tmp/A[i][i];
		}
}

void eliminacjad(double** A, double* B, int n) {
	int i, j, k;
	double tmp;

	for (i=0; i<n; i++)
		for (j=i+1; j<n; j++) {
			tmp = A[j][i];	
			for (k=i; k<n; k++)
				A[j][k] -= A[i][k]*tmp/A[i][i];
			B[j] -= B[i]*tmp/A[i][i];
		}
}

void wartoscif(float**A, float*x, float*B, int n) {
	int i, j;
	
	for (i=n-1; i>=0; i--) {
		x[i] = B[i];
		for (j=i+1; j<n; j++)
			x[i] = x[i] - A[i][j]*x[j];
		x[i] /= A[i][i];
	}
}

void wartoscid(double**A, double*x, double*B, int n) {
	int i, j;
	
	for (i=n-1; i>=0; i--) {
		x[i] = B[i];
		for (j=i+1; j<n; j++)
			x[i] = x[i] - A[i][j]*x[j];
		x[i] /= A[i][i];
	}
}

int main() {
	int i, j, n=0;
	float tmp;
	float*xf, **Af, *Bf;
	double*xd, **Ad, *Bd;
	double*x;
	double ed=0, ef=0;
		
	printf("Podaj ilosc rownan:\n");
	scanf("%d", &n);

	if (n<5) {
		fprintf(stderr, "Blad!\n");
		return EXIT_FAILURE;
	}

	xf = malloc(n*sizeof(float));
	xd = malloc(n*sizeof(double));
	x = malloc(n*sizeof(double));
	
	printf("Podaj wartosci dla wektora x:\n");
	for (i=0; i<n; i++) {
		scanf("%f", &tmp);
		xf[i] = tmp;
		xd[i] = tmp;
		x[i] = tmp;
	}

	Bf = malloc(n*sizeof(float));
	Bd = malloc(n*sizeof(double));
	
	Af = malloc(n*sizeof(float*));
	Ad = malloc(n*sizeof(double*));
	for (i=0; i<n; i++) {
		Af[i] = malloc(n*sizeof(float));
		Ad[i] = malloc(n*sizeof(double));
	}
	
	indeksujf(Af, xf, Bf, n);
	eliminacjaf(Af, Bf, n);
	wartoscif(Af, xf, Bf, n);
	indeksujd(Ad, xd, Bd, n);
	eliminacjad(Ad, Bd, n);
	wartoscid(Ad, xd, Bd, n);
	
	printf("Wartosci obliczone dla pojedynczej precyzji:\n");
	for (i=0; i<n; i++)
		printf("%20.20f\n", xf[i]);

	printf("Wartosci obliczone dla podwojnej precyzji:\n");
	for (i=0; i<n; i++)
		printf("%20.20f\n", xd[i]);

	for (i=0; i<n; i++)
		ef += fabs(x[i] - xf[i]);
	ef /= n;
		
	for (i=0; i<n; i++)
		ed += fabs(x[i] - xd[i]);
	ed /= n;
		
	printf("Sredni bezwzgledny blad dla pojedynczej precyzji: %20.20f\n", ef);
	printf("Sredni bezwzgledny blad dla podwojnej precyzji: %20.20f\n", ed);
	
	return EXIT_SUCCESS;
}
