#include <stdlib.h>
#include <math.h>
#include <string.h>
#include <stdio.h>

#define n 3

void indeksuj(double** A, double*B) {
	A[0][0]=0.00001;
	A[0][1]=0.00001;
	A[0][2]=1.0;
	A[1][0]=0.00001;
	A[1][1]=-0.00001;
	A[1][2]=1.0;
	A[2][0]=1.0;
	A[2][1]=1.0;
	A[2][2]=2.0;
	
	B[0] = 0.00002;
	B[1] = -0.00002;
	B[2] = 1.0;
}

void indeksuj_zr(double** A, double*B) {
	A[0][0]=1.0; A[0][1]= 1.0; A[0][2]=1.0;
	A[1][0]=1.0; A[1][1]=-1.0; A[1][2]=1.0;
	A[2][0]=1.0; A[2][1]= 1.0; A[2][2]=0.00002;
	
	B[0] = 2.0;
	B[1] = -2.0;
	B[2] = 1.0;
}

int* gauss2(double**A, double*B) {
	int row,column,k, i, j;
    	double tmp, wsp, suma;
	double* tmp_tab=(double*) calloc(n,sizeof(double));
	static int kolejnosc[n];
	
	for (i=0 ; i<n; i++)
    		kolejnosc[i]=i;
		
	for ( i=0 ; i<n-1 ; i++ ) {
		tmp=-1;
    		for (j=i ; j<n ; j++)
			for (k=i; k<n; k++)
	    			if (fabs(A[j][k])>tmp) {
		    			tmp=fabs(A[j][k]);
		    			row=j;
		    			column=k;
		    		}

    		for (j=0 ; j<n; j++)
			tmp_tab[j]=A[i][j];
	    	for (j=0 ; j<n; j++)
			A[i][j]=A[row][j];
    		for (j=0 ; j<n; j++)
			A[row][j]=tmp_tab[j];
	    	tmp=B[row];
	    	B[row]=B[i];
	    	B[i]=tmp;
	
		for (j=0 ; j<n; j++)
			tmp_tab[j]=A[j][i];
    		for (j=0 ; j<n; j++)
			A[j][i]=A[j][column];
    		for (j=0 ; j<n; j++)
			A[j][column]=tmp_tab[j];
    		k=kolejnosc[i];
    		kolejnosc[i]=kolejnosc[column];
    		kolejnosc[column]=k;

    		for ( j=i+1 ; j<n ; j++ ) {
			wsp=-A[j][i]/A[i][i];
	    		for ( k=i ; k<n ; k++ )
				A[j][k]+=wsp*A[i][k];
			B[j]+=wsp*B[i];
		}
    	}
	free(tmp_tab);
	return kolejnosc;
}

void gauss1(double** A, double* B) {
	int i, j, k;
	double tmp;

	for (i=0; i<n; i++)
		for (j=i+1; j<n; j++) {
			tmp = A[j][i];	
			for (k=i; k<n; k++)
				A[j][k] -= A[i][k]*tmp/A[i][i];
			B[j] -= B[i]*tmp/A[i][i];
		}
}

void wartoscid(double**A, double*x, double*B) {
	int i, j;
	
	for (i=n-1; i>=0; i--) {
		x[i] = B[i];
		for (j=i+1; j<n; j++)
			x[i] = x[i] - A[i][j]*x[j];
		x[i] /= A[i][i];
	}
}

int main() {
	double B[n];
	double* A[n];
	int j, *kolejnosc;
	double* x_wektor=(double*)calloc(n,sizeof(double));
	double xdok[] = {-1/0.99998, 2, 0.00001/0.99998};
	double e = 0;

	for (j=0 ; j<n; j++)
		A[j]=(double*)calloc(n,sizeof(double));

	indeksuj(A, B);
	gauss1(A, B);

	wartoscid(A, x_wektor, B);

	printf("Wartosci obliczone bez wyboru elementow glownych:\n");
		
	for (j=0; j<n; j++)
		printf("%20.20f\n", x_wektor[j]);

	for (j=0; j<n; j++)
		e += fabs(x_wektor[j] - xdok[j]);
	e /= n;
		
	printf("Sredni blad bezwzgledny: %40.40f\n\n", e);
	
	indeksuj(A, B);
	kolejnosc = gauss2(A, B);

	wartoscid(A, x_wektor, B);

	printf("Wartosci obliczone dla pelnego wyboru elementow glownych:\n");

	for (j=0; j<n; j++)
		printf("%20.20f\n", x_wektor[kolejnosc[j]]);

	e = 0;
	for (j=0; j<n; j++)
		e += fabs(x_wektor[kolejnosc[j]] - xdok[j]);
	e /= n;
		
	printf("Sredni blad bezwzgledny: %40.40f\n\n", e);
				
	indeksuj_zr(A, B);
	gauss2(A, B);

	wartoscid(A, x_wektor, B);
	x_wektor[2] /= 100000;
	
	printf("Wartosci obliczone dla pelnego wyboru elementow glownych po skalowaniu i zrownowazeniu macierzy:\n");

	for (j=0; j<n; j++)
		printf("%20.20f\n", x_wektor[kolejnosc[j]]);
	
	e = 0;
	for (j=0; j<n; j++)
		e += fabs(x_wektor[kolejnosc[j]] - xdok[j]);
	e /= n;
		
	printf("Sredni blad bezwzgledny: %40.40f\n\n", e);
			
	return EXIT_SUCCESS;
}
